<!DOCTYPE html>
<html>

<head>
    <meta charset='utf-8'>
    <title> 06 API sample cho Pizza 365 Project</title>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>


<!-- file html dùng để thử tác động của javascript vào các thành phần trang web-->
<script>
    "use strict";
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gREQUEST_CREATE_SUCCESS = 201;
    //gọi mẫu lấy danh sách order
    function onBtnGetAllOrderClick() {
        "use strict";
        //base url
        const vBaseUrl = "http://42.115.221.44:8080/devcamp-pizza365/orders";

        // create a request
        var vXmlHttpGetAllOrder = new XMLHttpRequest();
        vXmlHttpGetAllOrder.open("GET", vBaseUrl, true);
        vXmlHttpGetAllOrder.send();
        vXmlHttpGetAllOrder.onreadystatechange =
            function() {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vOrderList = vXmlHttpGetAllOrder.responseText;
                    console.log(vOrderList);
                }
            }

    }

    //gọi tạo một order mới
    function onBtnCreateOrderClick() {
        "use strict";
        //base url
        const vBaseUrl = "http://42.115.221.44:8080/devcamp-pizza365/orders";
        var vObjectRequest = {
            kichCo: "M",
            duongKinh: "25",
            suon: "4",
            salad: "300",
            loaiPizza: "HAWAII",
            idVourcher: "16512",
            idLoaiNuocUong: "PEPSI",
            soLuongNuoc: "3",
            hoTen: "Phạm Thanh Bình",
            thanhTien: "200000",
            email: "binhpt001@devcamp.edu.vn",
            soDienThoai: "0865241654",
            diaChi: "Hà Nội",
            loiNhan: "Pizza đế dày"
        }

        var vXmlHttpCreateOrder = new XMLHttpRequest();
        vXmlHttpCreateOrder.open("POST", vBaseUrl, true);
        vXmlHttpCreateOrder.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        vXmlHttpCreateOrder.send(JSON.stringify(vObjectRequest));
        vXmlHttpCreateOrder.onreadystatechange =
            function() {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_CREATE_SUCCESS) { // status 201 tao thanh cong
                    var vCreatedOrder = vXmlHttpCreateOrder.responseText;
                    console.log(vCreatedOrder);
                }
            }
    }

    //gọi mẫu lấy dic history
    function onBtnGetOrderByIdClick() {
        "use strict";
        //base url
        const vBaseUrl = "http://42.115.221.44:8080/devcamp-pizza365/orders";
        var vOrderId = "THUzgEgFC6";

        var vXmlHttpGetOrderById = new XMLHttpRequest();
        vXmlHttpGetOrderById.open("GET", vBaseUrl + "/" + vOrderId, true);
        vXmlHttpGetOrderById.send();
        vXmlHttpGetOrderById.onreadystatechange =
            function() {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXmlHttpGetOrderById.responseText);
                }
            }
    }

    //update một order mới
    function onBtnUpdateOrderClick() {
        "use strict";
        //base url
        const vBaseUrl = "http://42.115.221.44:8080/devcamp-pizza365/orders";
        var vOderId = "6910";
        var vObjectRequest = {
            trangThai: "confirmed" //3 trang thai open, confirmed, cancel
        }

        var vXmlHttpUpdateOrder = new XMLHttpRequest();
        vXmlHttpUpdateOrder.open("PUT", vBaseUrl + "/" + vOderId);
        vXmlHttpUpdateOrder.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        vXmlHttpUpdateOrder.send(JSON.stringify(vObjectRequest));
        vXmlHttpUpdateOrder.onreadystatechange =
            function() {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    var vUpdatedOrder = vXmlHttpUpdateOrder.responseText;
                    console.log(vUpdatedOrder);
                }
            }
    }

    //check mã giảm giá

    function onBtnCheckVoucherIdClick() {
        "use strict";
        var vVoucherId = "12332"; //một số mã đúng để test: 95531, 81432,...lưu ý test cả mã sai
        // nếu mã giảm giấ đã nhập, tạo xmlHttp  request và gửi về server
        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("GET", "http://42.115.221.44:8080/devcamp-voucher-api/voucher_detail/" + vVoucherId, false);
        vXmlHttp.send(null);
        var vStatusCode = vXmlHttp.status;
        if (vStatusCode == gREQUEST_STATUS_OK) { // restFullAPI successful
            // nhận lại response dạng JSON ở vXmlHttp.responseText và chuyển thành object
            console.log(vXmlHttp.responseText);
        } else {
            // không nhận lại được data do vấn đề gì đó: khả năng mã voucher ko dúng
            console.log("Không tìm thấy voucher " + vXmlHttp.responseText);
        }
    }

    //mã nguồn để load data drink list (danh sách loại nước uống) về
    function onBtnGetDrinkListClick() {
        "use strict";
        var vXhttp = new XMLHttpRequest();
        vXhttp.onreadystatechange =
            function() {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(vXhttp.responseText); //ghi response text ra console.log
                }
            };
        vXhttp.open("GET", "http://42.115.221.44:8080/devcamp-pizza365/drinks", true);
        vXhttp.send();
    }
</script>

<body class="bg-light">
    <div class="container">
        <div class="form-group">
            <p id="cmt2dev">Test Page for Javascrip Tasks. F5 to run code. </p>
        </div>
        <div class="form-group">
            <form id="singleForm w-75">
                <input type="button" class="btn btn-primary p-2" onclick="onBtnGetAllOrderClick()" value="Call api get all orders!">
                <input type="button" class="btn btn-info p-2" onclick="onBtnCreateOrderClick()" value="Call api create order!">
                <input type="button" class="btn btn-success p-2" onclick="onBtnGetOrderByIdClick()" value="Call api get order by id!">
                <input type="button" class="btn btn-secondary p-2" onclick="onBtnUpdateOrderClick()" value="Call api update order!">
                <input type="button" class="btn btn-danger p-2" onclick="onBtnCheckVoucherIdClick()" value="Call api check voucher by id!">
                <input type="button" class="btn btn-success p-2" onclick="onBtnGetDrinkListClick()" value="Call api Get drink list!">
            </form>
        </div>
        <div class="form-group">
            <p id="testP" style="font-size:larger;"> Demo 06 API for Pizza 365 Project: </p>
            <ul>
                <li>get all Orders: lấy tất cả orders </li>
                <li>create Order: tạo 1 order</li>
                <li>get Order by ID: lấy 1 order bằng ID </li>
                <li>update Order: update 01 order</li>
                <li>check voucher by ID: check thông tin mã giảm giá, quan trọng là có hay không, và % giảm giá </li>
                <li>get drink list: lấy danh sách đồ uống</li>
            </ul>
            <strong class="text-danger"> Bật console log để nhìn rõ output </strong>
        </div>
    </div>
</body>

</html>